__gnu_debug Namespace Reference

## Classes

class | _After_nth_from
struct | _BeforeBeginHelper
class | _Equal_to
class | _Not_equal_to
class | _Safe_container
class | _Safe_forward_list
class | _Safe_iterator
class | _Safe_iterator_base
class | _Safe_local_iterator
class | _Safe_local_iterator_base
class | _Safe_node_sequence
class | _Safe_sequence
class | _Safe_sequence_base
class | _Safe_unordered_container
class | _Safe_unordered_container_base
class | _Safe_vector
class | basic_string

## Typedefs

typedef basic_string< char > | string
typedef basic_string< wchar_t > | wstring

## Enumerations

enum

_Debug_msg_id {
__msg_valid_range, __msg_insert_singular, __msg_insert_different, __msg_erase_bad,
__msg_erase_different, __msg_subscript_oob, __msg_empty, __msg_unpartitioned,
__msg_unpartitioned_pred, __msg_unsorted, __msg_unsorted_pred, __msg_not_heap,
__msg_not_heap_pred, __msg_bad_bitset_write, __msg_bad_bitset_read, __msg_bad_bitset_flip,
__msg_self_splice, __msg_splice_alloc, __msg_splice_bad, __msg_splice_other,
__msg_splice_overlap, __msg_init_singular, __msg_init_copy_singular, __msg_init_const_singular,
__msg_copy_singular, __msg_bad_deref, __msg_bad_inc, __msg_bad_dec,
__msg_iter_subscript_oob, __msg_advance_oob, __msg_retreat_oob, __msg_iter_compare_bad,
__msg_compare_different, __msg_iter_order_bad, __msg_order_different, __msg_distance_bad,
__msg_distance_different, __msg_deref_istream, __msg_inc_istream, __msg_output_ostream,
__msg_deref_istreambuf, __msg_inc_istreambuf, __msg_insert_after_end, __msg_erase_after_bad,
__msg_valid_range2, __msg_local_iter_compare_bad, __msg_non_empty_range, __msg_self_move_assign,
__msg_bucket_index_oob, __msg_valid_load_factor, __msg_equal_allocs, __msg_insert_range_from_self
}

enum | _Distance_precision { __dp_equality, __dp_sign, __dp_exact }

## Functions

template<typename _Iterator >
_Siter_base< _Iterator >::iterator_type | __base (_Iterator __it)
template<typename _Iterator >
bool | __check_dereferenceable (const _Iterator &)
template<typename _Tp >
bool | __check_dereferenceable (const _Tp *__ptr)
template<typename _Iterator , typename _Sequence >
bool | __check_dereferenceable (const _Safe_iterator< _Iterator, _Sequence > &__x)
template<typename _Iterator , typename _Sequence >
bool | __check_dereferenceable (const _Safe_local_iterator< _Iterator, _Sequence > &__x)
template<typename _ForwardIterator , typename _Tp >
bool | __check_partitioned_lower (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__value)
template<typename _ForwardIterator , typename _Tp , typename _Pred >
bool | __check_partitioned_lower (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__value, _Pred __pred)
template<typename _ForwardIterator , typename _Tp >
bool | __check_partitioned_upper (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__value)
template<typename _ForwardIterator , typename _Tp , typename _Pred >
bool | __check_partitioned_upper (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__value, _Pred __pred)
template<typename _Iterator >
bool | __check_singular (const _Iterator &)
template<typename _Tp >
bool | __check_singular (const _Tp *__ptr)
bool | __check_singular_aux (const void *)
bool | __check_singular_aux (const _Safe_iterator_base *__x)
template<typename _InputIterator >
bool | __check_sorted (const _InputIterator &__first, const _InputIterator &__last)
template<typename _InputIterator , typename _Predicate >
bool | __check_sorted (const _InputIterator &__first, const _InputIterator &__last, _Predicate __pred)
template<typename _InputIterator >
bool | __check_sorted_aux (const _InputIterator &, const _InputIterator &, std::input_iterator_tag)
template<typename _ForwardIterator >
bool | __check_sorted_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator , typename _Predicate >
bool | __check_sorted_aux (const _InputIterator &, const _InputIterator &, _Predicate, std::input_iterator_tag)
template<typename _ForwardIterator , typename _Predicate >
bool | __check_sorted_aux (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred, std::forward_iterator_tag)
template<typename _InputIterator1 , typename _InputIterator2 >
bool | __check_sorted_set (const _InputIterator1 &__first, const _InputIterator1 &__last, const _InputIterator2 &)
template<typename _InputIterator1 , typename _InputIterator2 , typename _Predicate >
bool | __check_sorted_set (const _InputIterator1 &__first, const _InputIterator1 &__last, const _InputIterator2 &, _Predicate __pred)
template<typename _InputIterator >
bool | __check_sorted_set_aux (const _InputIterator &__first, const _InputIterator &__last, std::__true_type)
template<typename _InputIterator >
bool | __check_sorted_set_aux (const _InputIterator &, const _InputIterator &, std::__false_type)
template<typename _InputIterator , typename _Predicate >
bool | __check_sorted_set_aux (const _InputIterator &__first, const _InputIterator &__last, _Predicate __pred, std::__true_type)
template<typename _InputIterator , typename _Predicate >
bool | __check_sorted_set_aux (const _InputIterator &, const _InputIterator &, _Predicate, std::__false_type)
template<typename _CharT , typename _Integer >
const _CharT * | __check_string (const _CharT *__s, const _Integer &__n __attribute__((__unused__)))
template<typename _CharT >
const _CharT * | __check_string (const _CharT *__s)
template<typename _InputIterator >
_InputIterator | __check_valid_range (const _InputIterator &__first, const _InputIterator &__last __attribute__((__unused__)))
template<typename _Iterator , typename _Sequence , typename _InputIterator >
bool | __foreign_iterator (const _Safe_iterator< _Iterator, _Sequence > &__it, _InputIterator __other, _InputIterator __other_end)
template<typename _Iterator , typename _Sequence , typename _Integral >
bool | __foreign_iterator_aux (const _Safe_iterator< _Iterator, _Sequence > &, _Integral, _Integral, std::__true_type)
template<typename _Iterator , typename _Sequence , typename _InputIterator >
bool | __foreign_iterator_aux (const _Safe_iterator< _Iterator, _Sequence > &__it, _InputIterator __other, _InputIterator __other_end, std::__false_type)
template<typename _Iterator , typename _Sequence , typename _OtherIterator >
bool | __foreign_iterator_aux2 (const _Safe_iterator< _Iterator, _Sequence > &__it, const _Safe_iterator< _OtherIterator, _Sequence > &__other, const _Safe_iterator< _OtherIterator, _Sequence > &)
template<typename _Iterator , typename _Sequence , typename _OtherIterator , typename _OtherSequence >
bool | __foreign_iterator_aux2 (const _Safe_iterator< _Iterator, _Sequence > &__it, const _Safe_iterator< _OtherIterator, _OtherSequence > &, const _Safe_iterator< _OtherIterator, _OtherSequence > &)
template<typename _Iterator , typename _Sequence , typename _InputIterator >
bool | __foreign_iterator_aux2 (const _Safe_iterator< _Iterator, _Sequence > &__it, const _InputIterator &__other, const _InputIterator &__other_end)
template<typename _Iterator , typename _Sequence , typename _InputIterator >
bool | __foreign_iterator_aux3 (const _Safe_iterator< _Iterator, _Sequence > &__it, const _InputIterator &__other, const _InputIterator &__other_end, std::__true_type)
template<typename _Iterator , typename _Sequence , typename _InputIterator >
bool | __foreign_iterator_aux3 (const _Safe_iterator< _Iterator, _Sequence > &, const _InputIterator &, const _InputIterator &, std::__false_type)
template<typename _Iterator , typename _Sequence >
bool | __foreign_iterator_aux4 (const _Safe_iterator< _Iterator, _Sequence > &__it, const typename _Sequence::value_type *__other)
template<typename _Iterator , typename _Sequence >
bool | __foreign_iterator_aux4 (const _Safe_iterator< _Iterator, _Sequence > &,...)
template<typename _Iterator >
std::pair< typename std::iterator_traits< _Iterator >::difference_type, _Distance_precision > | __get_distance (const _Iterator &__lhs, const _Iterator &__rhs, std::random_access_iterator_tag)
template<typename _Iterator >
std::pair< typename std::iterator_traits< _Iterator >::difference_type, _Distance_precision > | __get_distance (const _Iterator &__lhs, const _Iterator &__rhs, std::forward_iterator_tag)
template<typename _Iterator >
std::pair< typename std::iterator_traits< _Iterator >::difference_type, _Distance_precision > | __get_distance (const _Iterator &__lhs, const _Iterator &__rhs)
template<typename _InputIterator >
bool | __valid_range (const _InputIterator &__first, const _InputIterator &__last)
template<typename _Iterator , typename _Sequence >
bool | __valid_range (const _Safe_iterator< _Iterator, _Sequence > &__first, const _Safe_iterator< _Iterator, _Sequence > &__last)
template<typename _Iterator , typename _Sequence >
bool | __valid_range (const _Safe_local_iterator< _Iterator, _Sequence > &__first, const _Safe_local_iterator< _Iterator, _Sequence > &__last)
template<typename _Integral >
bool | __valid_range_aux (const _Integral &, const _Integral &, std::__true_type)
template<typename _InputIterator >
bool | __valid_range_aux (const _InputIterator &__first, const _InputIterator &__last, std::__false_type)
template<typename _RandomAccessIterator >
bool | __valid_range_aux2 (const _RandomAccessIterator &__first, const _RandomAccessIterator &__last, std::random_access_iterator_tag)
template<typename _InputIterator >
bool | __valid_range_aux2 (const _InputIterator &, const _InputIterator &, std::input_iterator_tag)
template<typename _CharT , typename _Traits , typename _Allocator >
std::basic_istream< _CharT, _Traits > & | getline (std::basic_istream< _CharT, _Traits > &__is, basic_string< _CharT, _Traits, _Allocator > &__str, _CharT __delim)
template<typename _CharT , typename _Traits , typename _Allocator >
std::basic_istream< _CharT, _Traits > & | getline (std::basic_istream< _CharT, _Traits > &__is, basic_string< _CharT, _Traits, _Allocator > &__str)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator!= (const _Safe_local_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_local_iterator< _IteratorR, _Sequence > &__rhs)
template<typename _Iterator , typename _Sequence >
bool | operator!= (const _Safe_local_iterator< _Iterator, _Sequence > &__lhs, const _Safe_local_iterator< _Iterator, _Sequence > &__rhs)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator!= (const _Safe_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_iterator< _IteratorR, _Sequence > &__rhs) noexcept
template<typename _Iterator , typename _Sequence >
bool | operator!= (const _Safe_iterator< _Iterator, _Sequence > &__lhs, const _Safe_iterator< _Iterator, _Sequence > &__rhs) noexcept
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator!= (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator!= (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator!= (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const _CharT *__rhs)
template<typename _Iterator , typename _Sequence >
_Safe_iterator< _Iterator, _Sequence > | operator+ (typename _Safe_iterator< _Iterator, _Sequence >::difference_type __n, const _Safe_iterator< _Iterator, _Sequence > &__i) noexcept
template<typename _CharT , typename _Traits , typename _Allocator >
basic_string< _CharT, _Traits, _Allocator > | operator+ (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
basic_string< _CharT, _Traits, _Allocator > | operator+ (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
basic_string< _CharT, _Traits, _Allocator > | operator+ (_CharT __lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
basic_string< _CharT, _Traits, _Allocator > | operator+ (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const _CharT *__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
basic_string< _CharT, _Traits, _Allocator > | operator+ (const basic_string< _CharT, _Traits, _Allocator > &__lhs, _CharT __rhs)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
_Safe_iterator< _IteratorL, _Sequence >::difference_type | operator- (const _Safe_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_iterator< _IteratorR, _Sequence > &__rhs) noexcept
template<typename _Iterator , typename _Sequence >
_Safe_iterator< _Iterator, _Sequence >::difference_type | operator- (const _Safe_iterator< _Iterator, _Sequence > &__lhs, const _Safe_iterator< _Iterator, _Sequence > &__rhs) noexcept
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator< (const _Safe_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_iterator< _IteratorR, _Sequence > &__rhs) noexcept
template<typename _Iterator , typename _Sequence >
bool | operator< (const _Safe_iterator< _Iterator, _Sequence > &__lhs, const _Safe_iterator< _Iterator, _Sequence > &__rhs) noexcept
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator< (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator< (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator< (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const _CharT *__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
std::basic_ostream< _CharT, _Traits > & | operator<< (std::basic_ostream< _CharT, _Traits > &__os, const basic_string< _CharT, _Traits, _Allocator > &__str)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator<= (const _Safe_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_iterator< _IteratorR, _Sequence > &__rhs) noexcept
template<typename _Iterator , typename _Sequence >
bool | operator<= (const _Safe_iterator< _Iterator, _Sequence > &__lhs, const _Safe_iterator< _Iterator, _Sequence > &__rhs) noexcept
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator<= (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator<= (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator<= (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const _CharT *__rhs)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator== (const _Safe_local_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_local_iterator< _IteratorR, _Sequence > &__rhs)
template<typename _Iterator , typename _Sequence >
bool | operator== (const _Safe_local_iterator< _Iterator, _Sequence > &__lhs, const _Safe_local_iterator< _Iterator, _Sequence > &__rhs)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator== (const _Safe_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_iterator< _IteratorR, _Sequence > &__rhs) noexcept
template<typename _Iterator , typename _Sequence >
bool | operator== (const _Safe_iterator< _Iterator, _Sequence > &__lhs, const _Safe_iterator< _Iterator, _Sequence > &__rhs) noexcept
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator== (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator== (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator== (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const _CharT *__rhs)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator> (const _Safe_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_iterator< _IteratorR, _Sequence > &__rhs) noexcept
template<typename _Iterator , typename _Sequence >
bool | operator> (const _Safe_iterator< _Iterator, _Sequence > &__lhs, const _Safe_iterator< _Iterator, _Sequence > &__rhs) noexcept
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator> (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator> (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator> (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const _CharT *__rhs)
template<typename _IteratorL , typename _IteratorR , typename _Sequence >
bool | operator>= (const _Safe_iterator< _IteratorL, _Sequence > &__lhs, const _Safe_iterator< _IteratorR, _Sequence > &__rhs) noexcept
template<typename _Iterator , typename _Sequence >
bool | operator>= (const _Safe_iterator< _Iterator, _Sequence > &__lhs, const _Safe_iterator< _Iterator, _Sequence > &__rhs) noexcept
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator>= (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator>= (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Allocator > &__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
bool | operator>= (const basic_string< _CharT, _Traits, _Allocator > &__lhs, const _CharT *__rhs)
template<typename _CharT , typename _Traits , typename _Allocator >
std::basic_istream< _CharT, _Traits > & | operator>> (std::basic_istream< _CharT, _Traits > &__is, basic_string< _CharT, _Traits, _Allocator > &__str)
template<typename _CharT , typename _Traits , typename _Allocator >
void | swap (basic_string< _CharT, _Traits, _Allocator > &__lhs, basic_string< _CharT, _Traits, _Allocator > &__rhs)

## Detailed Description

GNU debug classes for public use.

## Enumeration Type Documentation

## _Distance_precision

enum __gnu_debug::_Distance_precision

The precision to which we can calculate the distance between two iterators.

Definition at line 68 of file safe_iterator.h.

## Function Documentation

## __base()

template<typename _Iterator >

_Siter_base<_Iterator>::iterator_type __gnu_debug::__base | ( | _Iterator | __it | ) |

inline

Helper function to extract base iterator of random access safe iterator in order to reduce performance impact of debug mode. Limited to random access iterator because it is the only category for which it is possible to check for correct iterators order in the __valid_range function thanks to the < operator.

Definition at line 558 of file functions.h.

Referenced by __gnu_parallel::__for_each_template_random_access_workstealing(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_before_dereferenceable(), std::boolalpha(), std::dec(), std::defaultfloat(), std::fixed(), std::hex(), std::hexfloat(), std::internal(), std::left(), std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), std::nouppercase(), std::oct(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::right(), std::scientific(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

## __check_dereferenceable() [1/4]

template<typename _Iterator >

bool __gnu_debug::__check_dereferenceable | ( | const _Iterator & |  | ) |

inline

Assume that some arbitrary iterator is dereferenceable, because we can't prove that it isn't.

Definition at line 79 of file functions.h.

## __check_dereferenceable() [2/4]

template<typename _Tp >

bool __gnu_debug::__check_dereferenceable | ( | const _Tp * | __ptr | ) |

inline

Non-NULL pointers are dereferenceable.

Definition at line 85 of file functions.h.

## __check_dereferenceable() [3/4]

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::__check_dereferenceable | ( | const _Safe_iterator< _Iterator, _Sequence > & | __x | ) |

inline

Safe iterators know if they are dereferenceable.

Definition at line 91 of file functions.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_dereferenceable().

## __check_dereferenceable() [4/4]

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::__check_dereferenceable | ( | const _Safe_local_iterator< _Iterator, _Sequence > & | __x | ) |

inline

Safe local iterators know if they are dereferenceable.

Definition at line 97 of file functions.h.

## __check_singular()

template<typename _Tp >

bool __gnu_debug::__check_singular | ( | const _Tp * | __ptr | ) |

inline

Non-NULL pointers are nonsingular.

Definition at line 72 of file functions.h.

## __check_singular_aux()

bool __gnu_debug::__check_singular_aux | ( | const _Safe_iterator_base * | __x | ) |

inline

Iterators that derive from _Safe_iterator_base can be determined singular or non-singular.

Definition at line 62 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator_base::_M_singular().

## __check_string() [1/2]

template<typename _CharT , typename _Integer >

const _CharT* __gnu_debug::__check_string | ( | const _CharT * | __s,
|  | const _Integer &__n | __attribute__(__unused__)
| ) |  |

inline

Checks that __s is non-NULL or __n == 0, and then returns __s.

Definition at line 300 of file functions.h.

## __check_string() [2/2]

template<typename _CharT >

const _CharT* __gnu_debug::__check_string | ( | const _CharT * | __s | ) |

inline

Checks that __s is non-NULL and then returns __s.

Definition at line 312 of file functions.h.

## __foreign_iterator_aux2() [1/2]

template<typename _Iterator , typename _Sequence , typename _OtherIterator >

bool __gnu_debug::__foreign_iterator_aux2 | ( | const _Safe_iterator< _Iterator, _Sequence > & | __it,
|  | const _Safe_iterator< _OtherIterator, _Sequence > & | __other,
|  | const _Safe_iterator< _OtherIterator, _Sequence > & |
| ) |  |

inline

Handle debug iterators from the same type of container.

Definition at line 234 of file functions.h.

Referenced by __foreign_iterator_aux2().

## __foreign_iterator_aux2() [2/2]

template<typename _Iterator , typename _Sequence , typename _OtherIterator , typename _OtherSequence >

bool __gnu_debug::__foreign_iterator_aux2 | ( | const _Safe_iterator< _Iterator, _Sequence > & | __it,
|  | const _Safe_iterator< _OtherIterator, _OtherSequence > & | ,
|  | const _Safe_iterator< _OtherIterator, _OtherSequence > & |
| ) |  |

inline

Handle debug iterators from different types of container.

Definition at line 243 of file functions.h.

References __foreign_iterator_aux2().

## __get_distance()

template<typename _Iterator >

std::pair<typename std::iterator_traits<_Iterator>::difference_type, _Distance_precision> __gnu_debug::__get_distance | ( | const _Iterator & | __lhs,
|  | const _Iterator & | __rhs,
|  | std::random_access_iterator_tag |
| ) |  |

inline

Determine the distance between two iterators with some known precision.

Definition at line 81 of file safe_iterator.h.

References std::make_pair().

## __valid_range() [1/3]

template<typename _InputIterator >

bool __gnu_debug::__valid_range | ( | const _InputIterator & | __first,
|  | const _InputIterator & | __last
| ) |  |

inline

Don't know what these iterators are, or if they are even iterators (we may get an integral type for InputIterator), so see if they are integral and pass them on to the next phase otherwise.

Definition at line 147 of file functions.h.

References __valid_range_aux().

## __valid_range() [2/3]

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::__valid_range | ( | const _Safe_iterator< _Iterator, _Sequence > & | __first,
|  | const _Safe_iterator< _Iterator, _Sequence > & | __last
| ) |  |

inline

Safe iterators know how to check if they form a valid range.

Definition at line 156 of file functions.h.

## __valid_range() [3/3]

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::__valid_range | ( | const _Safe_local_iterator< _Iterator, _Sequence > & | __first,
|  | const _Safe_local_iterator< _Iterator, _Sequence > & | __last
| ) |  |

inline

Safe local iterators know how to check if they form a valid range.

Definition at line 163 of file functions.h.

## __valid_range_aux() [1/2]

template<typename _Integral >

bool __gnu_debug::__valid_range_aux | ( | const _Integral & | ,
|  | const _Integral & | ,
|  | std::__true_type |
| ) |  |

inline

We say that integral types for a valid range, and defer to other routines to realize what to do with integral types instead of iterators.

Definition at line 127 of file functions.h.

Referenced by __valid_range().

## __valid_range_aux() [2/2]

template<typename _InputIterator >

bool __gnu_debug::__valid_range_aux | ( | const _InputIterator & | __first,
|  | const _InputIterator & | __last,
|  | std::__false_type |
| ) |  |

inline

We have iterators, so figure out what kind of iterators that are to see if we can check the range ahead of time.

Definition at line 135 of file functions.h.

References std::__iterator_category(), and __valid_range_aux2().

## __valid_range_aux2() [1/2]

template<typename _RandomAccessIterator >

bool __gnu_debug::__valid_range_aux2 | ( | const _RandomAccessIterator & | __first,
|  | const _RandomAccessIterator & | __last,
|  | std::random_access_iterator_tag |
| ) |  |

inline

If the distance between two random access iterators is nonnegative, assume the range is valid.

Definition at line 106 of file functions.h.

Referenced by __valid_range_aux().

## __valid_range_aux2() [2/2]

template<typename _InputIterator >

bool __gnu_debug::__valid_range_aux2 | ( | const _InputIterator & | ,
|  | const _InputIterator & | ,
|  | std::input_iterator_tag |
| ) |  |

inline

Can't test for a valid range with input iterators, because iteration may be destructive. So we just assume that the range is valid.

Definition at line 117 of file functions.h.